## goldendict-webengine 22.11.24-alpha.221205.45d740a5

=== debian/changelog ===
goldendict-webengine (22.11.24-alpha.221205.45d740a5-2) unstable; urgency=medium

  * Source-only upload.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Dec 2022 15:27:27 -0500

goldendict-webengine (22.11.24-alpha.221205.45d740a5-1) unstable; urgency=medium

  * Initial release. (Closes: #1024862)
  * debian/copyright: Update icons copyright information.

 -- Boyuan Yang <byang@debian.org>  Tue, 06 Dec 2022 16:12:46 -0500
