## goldendict-webengine 22.12.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,18 @@
 # LINUX, APPLE and MSVC are used to detect system
 
 option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
-
+option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
 # Remove this once cmake 5.25 becomes minimum version
 if(UNIX AND NOT APPLE)
     set(LINUX TRUE)
 endif()
 
 if (APPLE)
-    add_subdirectory(eb)
+    if(WITH_EPWING_SUPPORT)
+    add_subdirectory(thirdparty/eb)
+    endif()
+
+    include_directories(/usr/local/include /opt/homebrew/include)
 endif ()
 
 project(goldendict
@@ -76,9 +80,12 @@
     find_package(X11 REQUIRED)
     pkg_check_modules (LIBXTST IMPORTED_TARGET xtst)
 
-    add_library(libeb SHARED IMPORTED)
-    set_target_properties(libeb PROPERTIES IMPORTED_LOCATION /usr/lib/libeb.so)
-    set_target_properties(libeb PROPERTIES INCLUDE_DIRECTORIES /usr/include/)
+    if(WITH_EPWING_SUPPORT)
+        add_subdirectory(thirdparty/eb EXCLUDE_FROM_ALL)
+    endif()
+    # add_library(libeb SHARED IMPORTED)
+    # set_target_properties(libeb PROPERTIES IMPORTED_LOCATION /usr/lib/libeb.so)
+    # set_target_properties(libeb PROPERTIES INCLUDE_DIRECTORIES /usr/include/)
 endif()
 
 #### Compile time files and preprocessor flags
@@ -144,7 +151,7 @@
         scanpopup.ui
         sources.ui
         )
-
+if(WITH_EPWING_SUPPORT)
 set(EPWING_SUPPORT_SRC
         epwing.cc
         epwing.hh
@@ -153,6 +160,9 @@
         epwing_charmap.cc
         epwing_charmap.hh
         )
+else()
+    add_compile_definitions(NO_EPWING_SUPPORT)
+endif()        
 
 if (APPLE)
     set(MAC_SRC
@@ -471,6 +481,9 @@
     target_include_directories(${CMAKE_PROJECT_NAME} PUBLIC
             ${CMAKE_SOURCE_DIR}/winlibs/include/
             )
+
+    set_property(TARGET ${CMAKE_PROJECT_NAME} PROPERTY 
+    MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")            
 endif()
 
 target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE
@@ -485,29 +498,10 @@
         )
 
 if(APPLE)
+    if(WITH_EPWING_SUPPORT)
     target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE eb)
+    endif()
 endif()
 
 if(UNIX)
-    target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE
-            # pkg-config packages need manually link
-            PkgConfig::PKGCONFIG_DEPS
-
-            BZip2::BZip2
-            ZLIB::ZLIB #hidden requirement of dsl_details.cc and more?
-            )
-endif()
-
-if(MSVC)
-    file(GLOB WINLIBS_FILES "${CMAKE_SOURCE_DIR}/winlibs/lib/msvc/*.lib")
-    foreach(A_WIN_LIB ${WINLIBS_FILES})
-        target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE ${A_WIN_LIB})
-    endforeach()
-endif()
-
-
-if(LINUX)
-    target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE libeb X11 PkgConfig::LIBXTST)
-endif ()
-
-if(APPLE)
+    target_include_directories(${CMAKE_PROJECT_NAME} PRIVATE
