=== debian/changelog ===
goldendict-webengine (22.12.20-1) unstable; urgency=medium

  * New upstream release 22.12.22-WinderSolstice.221220.311d08c6.
  * debian/patches: Add patch to disable new version check by default.

 -- Boyuan Yang <byang@debian.org>  Wed, 21 Dec 2022 16:32:44 -0500
