=== debian/changelog ===
goldendict-webengine (23.02.05-1) unstable; urgency=medium

  * New upstream release 23.02.06-LanternFestival.230205.9b8f85ca.
  * debian/rules: Enable use_iconv flag.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Feb 2023 21:02:13 -0500
