=== debian/changelog ===
goldendict-webengine (23.10.01-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:50:13 +1100

goldendict-webengine (23.10.01-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:30:48 +0000

goldendict-webengine (23.10.01-1build1) noble; urgency=medium

  * Rebuild against latest eb

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 14 Mar 2024 07:21:44 -0400

goldendict-webengine (23.10.01-1) unstable; urgency=medium

  * New upstream release 23.10.01-alpha.e69aabf2.
  * Branch from goldendict-ng project but keep using qmake and Qt5.

 -- Boyuan Yang <byang@debian.org>  Wed, 18 Oct 2023 14:02:22 -0400
