=== debian/control ===
Source: goldendict-webengine
Priority: optional
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Standards-Version: 4.6.2
Build-Depends:
 debhelper-compat (= 13),
 libavformat-dev,
 libavutil-dev,
 libbz2-dev,
 libeb16-dev,
 libfmt-dev,
 libhunspell-dev,
 libjs-jquery,
 liblzma-dev,
 liblzo2-dev,
 libopencc-dev (>= 1.1),
 libphonon4qt5-dev,
 libqt5svg5-dev,
 libqt5texttospeech5-dev,
 libqt5webchannel5-dev,
 libqt5x11extras5-dev,
 libtomlplusplus-dev,
 libvorbis-dev,
 libx11-dev,
 libxtst-dev,
 libzim-dev,
 libzstd-dev,
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
 qtmultimedia5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtwebengine5-dev,
 x11proto-record-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Homepage: https://github.com/xiaoyifang/goldendict-ng
Vcs-Browser: https://salsa.debian.org/debian/goldendict-ng
Vcs-Git: https://salsa.debian.org/debian/goldendict-ng.git

Package: goldendict-webengine
Architecture: any
Depends:
 libjs-jquery,
 libqt5multimedia5-plugins,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 goldendict,
 goldendict-ng,
Replaces:
 goldendict,
 goldendict-ng,
Provides:
 goldendict,
 goldendict-ng,
Description: feature-rich dictionary lookup program (NG/qtwebengine fork, Qt5)
 GoldenDict is a feature-rich dictionary lookup program, supporting multiple
 dictionary formats (StarDict/Babylon/Lingvo/Dictd/AARD/MDict/SDict)
 and online dictionaries, featuring perfect article rendering with the
 complete markup, illustrations and other content retained,
 and allowing you to type in words without any accents or correct case.
 .
 This is a forked version that uses QtWebEngine as rendering engine instead
 of QtWebKit. This package uses Qt5 as UI framework.
