=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT := 5

%:
	dh $@ --buildsystem=qmake

override_dh_auto_configure:
	dh_auto_configure -- \
	        CONFIG+=chinese_conversion_support \
	        CONFIG+=zim_support \
	        CONFIG+=use_iconv \
	        PREFIX=/usr \
		goldendict.pro

execute_before_dh_auto_configure:
	# Use unminified javascript sources
	ln -sf /usr/share/javascript/jquery/jquery.min.js src/scripts/jquery-3.6.0.slim.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js
	cp debian/missing-sources/popper.js src/scripts/popper.min.js
	cp debian/missing-sources/tippy-bundle.umd.js src/scripts/tippy.min.js
