## goldendict-webengine 24.02.16

=== debian/changelog ===
goldendict-webengine (24.02.16-1) unstable; urgency=medium

  * New upstream tag v24.02.16-alpha.fbe5335e.
  * Sync with goldendict-ng 24.02.16-1 upload, keep Qt5.

 -- Boyuan Yang <byang@debian.org>  Thu, 11 Apr 2024 23:22:34 -0400
