=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,4 @@
 	ln -sf /usr/share/javascript/jquery/jquery.min.js src/scripts/jquery-3.6.0.slim.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js
-	cp debian/missing-sources/popper.js src/scripts/popper.min.js
-	cp debian/missing-sources/tippy-bundle.umd.js src/scripts/tippy.min.js
