## goldendict-webengine 24.05.05

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,6 @@
 
 option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
 option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
-option(WITH_XAPIAN "enable Xapian support" ON)
 option(WITH_ZIM "enable zim support" ON)
 option(WITH_TTS "enable QTexttoSpeech support" ON)
 
@@ -22,31 +21,29 @@
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 23.09.08
+        VERSION 24.05.05
         LANGUAGES CXX C)
 
-if (NOT USE_ALTERNATIVE_NAME)
-    set(GOLDENDICT "goldendict") # binary/executable name
-else ()
+set(GOLDENDICT "goldendict") # binary/executable name
+if (USE_ALTERNATIVE_NAME )
     set(GOLDENDICT "goldendict-ng")
 endif ()
+if (APPLE)
+    set(GOLDENDICT "GoldenDict-ng")
+endif()
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 #### Qt
 
-find_package(Qt6 REQUIRED COMPONENTS
-        Concurrent
-        Core5Compat
-        LinguistTools
-        Multimedia
-        WebEngineWidgets
-        Widgets
-        Svg
-        Xml
-        TextToSpeech
-        )
+set(GD_QT_COMPONENTS Concurrent Core5Compat LinguistTools Multimedia PrintSupport WebEngineWidgets Widgets Svg Xml)
+
+if (WITH_TTS)
+    list(APPEND GD_QT_COMPONENTS TextToSpeech)
+endif ()
+
+find_package(Qt6 REQUIRED COMPONENTS ${GD_QT_COMPONENTS})
 
 qt_standard_project_setup() # availiable after find_package(Qt6 .... Core
 set(CMAKE_AUTORCC ON) # not included in the qt_standard_project_setup
@@ -54,7 +51,7 @@
 #### Things required during configuration
 
 block() # generate version.txt
-    string(TIMESTAMP build_time)
+    string(TIMESTAMP build_time UTC)
     find_package(Git)
     if (EXISTS "${CMAKE_SOURCE_DIR}/.git" AND GIT_FOUND)
         execute_process(
@@ -85,6 +82,9 @@
 
 if (APPLE)
     file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/macos/*.mm)
+
+    set(MACOS_APP_ICON ${CMAKE_SOURCE_DIR}/icons/macicon.icns)
+    set_source_files_properties(${MACOS_APP_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
 endif ()
 
 if (WIN32)
@@ -107,6 +107,7 @@
         src/stylesheets/css.qrc
         ${ALL_SOURCE_FILES}
         ${MACOS_SOURCE_FILES}
+        ${MACOS_APP_ICON}
         ${QSINGLEAPP_SOURCE_FILES}
         ${WINDOWS_ICON_RC}
 )
@@ -125,12 +126,15 @@
         Qt6::Concurrent
         Qt6::Core5Compat
         Qt6::Multimedia
+        Qt6::PrintSupport
         Qt6::WebEngineWidgets
         Qt6::Widgets
         Qt6::Svg
-        Qt6::TextToSpeech
         )
 
+if (WITH_TTS)
+    target_link_libraries(${GOLDENDICT} PRIVATE Qt6::TextToSpeech)
+endif ()
 
 target_include_directories(${GOLDENDICT} PRIVATE
         ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src
@@ -170,11 +174,6 @@
     target_compile_definitions(${GOLDENDICT} PUBLIC NO_EPWING_SUPPORT)
 endif ()
 
-
-if (WITH_XAPIAN)
-    target_compile_definitions(${GOLDENDICT} PUBLIC USE_XAPIAN)
-endif ()
-
 if (WITH_ZIM)
     target_compile_definitions(${GOLDENDICT} PUBLIC MAKE_ZIM_SUPPORT)
 endif ()
@@ -205,12 +204,53 @@
 #### installation or assemble redistribution
 
 if (APPLE)
+    set(PLIST_FILE "${CMAKE_BINARY_DIR}/info_generated.plist")
+    configure_file("${CMAKE_SOURCE_DIR}/redist/mac_info_plist_template_cmake.plist" "${PLIST_FILE}" @ONLY)
+
     set_target_properties(${GOLDENDICT} PROPERTIES
-            MACOSX_BUNDLE_GUI_IDENTIFIER my.example.com
-            MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
-            MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
             MACOSX_BUNDLE TRUE
-            )
+            MACOSX_BUNDLE_INFO_PLIST "${PLIST_FILE}"
+    )
+
+    set(Assembling_Dir "${CMAKE_BINARY_DIR}/redist")
+    set(App_Name "${GOLDENDICT}.app")
+    set(Redistributable_APP "${Assembling_Dir}/${App_Name}")
+    
+    qt_generate_deploy_script(
+            TARGET ${GOLDENDICT}
+            OUTPUT_SCRIPT deploy_script
+            CONTENT "qt_deploy_runtime_dependencies(
+                        EXECUTABLE \"${Redistributable_APP}\"
+                        GENERATE_QT_CONF
+                        NO_APP_STORE_COMPLIANCE
+                )"
+    )
+
+    install(TARGETS ${GOLDENDICT} BUNDLE DESTINATION "${Assembling_Dir}")
+    install(FILES ${qm_files} DESTINATION "${Redistributable_APP}/Contents/MacOS/locale")
+    install(DIRECTORY "${CMAKE_SOURCE_DIR}/opencc" DESTINATION "${Redistributable_APP}/Contents/MacOS")
+
+    install(SCRIPT ${deploy_script})
+
+    install(CODE "execute_process(COMMAND codesign --force --deep -s - ${Redistributable_APP})")
+
+    find_program(CREATE-DMG "create-dmg")
+    if (CREATE-DMG)
+        install(CODE "
+        execute_process(COMMAND ${CREATE-DMG} \
+            --skip-jenkins \
+            --format \"ULMO\"
+            --volname ${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION}-${CMAKE_SYSTEM_PROCESSOR} \
+            --volicon ${CMAKE_SOURCE_DIR}/icons/macicon.icns \
+            --icon \"${App_Name}\" 100 100
+            --app-drop-link 300 100 \
+            \"GoldenDict-${CMAKE_PROJECT_VERSION}-Qt${Qt6_VERSION}-${CMAKE_SYSTEM_PROCESSOR}.dmg\" \
+            \"${Assembling_Dir}\")"
+        )
+    else ()
+        message(WARNING "create-dmg not found. No .dmg will be created")
+    endif ()
+
 endif ()
 
 if (LINUX OR BSD)
@@ -239,7 +279,6 @@
 endif ()
 
 if (WIN32)
-    find_program(TOOL_WINDEPLOYQT NAMES windeployqt PATHS "${Qt6_ROOT}/bin")
     set_target_properties(${GOLDENDICT}
             PROPERTIES
             WIN32_EXECUTABLE TRUE
@@ -250,14 +289,24 @@
     add_custom_target(windeploy
             COMMENT "Deploy everything to the output dir"
             DEPENDS ${GOLDENDICT} # build this target will check if Goldendict.exe is already built
-            COMMAND ${TOOL_WINDEPLOYQT} --no-quick-import "${GD_WIN_OUTPUT_DIR}/${GOLDENDICT}.exe" --plugindir "${GD_WIN_OUTPUT_DIR}/plugins"
+            COMMAND ${WINDEPLOYQT_EXECUTABLE} --no-quick-import "${GD_WIN_OUTPUT_DIR}/${GOLDENDICT}.exe" --plugindir "${GD_WIN_OUTPUT_DIR}/plugins"
             COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_SOURCE_DIR}/opencc" "${GD_WIN_OUTPUT_DIR}/opencc"
             COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/LICENSE.txt" "${GD_WIN_OUTPUT_DIR}/LICENSE.txt"
             COMMAND ${CMAKE_COMMAND} -E rm -f "${GD_WIN_OUTPUT_DIR}/goldendict.exe.manifest" "${GD_WIN_OUTPUT_DIR}/eb.dll.manifest"
             WORKING_DIRECTORY ${GD_WIN_OUTPUT_DIR}
     )
 
-    #TODO: use CPack to make the output folder as NSIS installer
+    # use CPack to make the output folder as NSIS installer
+    install(
+        DIRECTORY "${GD_WIN_OUTPUT_DIR}/"
+        DESTINATION .
+    )
+
+    set(CPACK_PACKAGE_FILE_NAME "${Qt6Widgets_VERSION}-${PROJECT_NAME}-${PROJECT_VERSION}-${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
+    set(CPACK_GENERATOR "7Z;NSIS")
+    set(CPACK_NSIS_MANIFEST_DPI_AWARE ON)
+    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt")
+    include(CPack)
 endif ()
 
 feature_summary(WHAT ALL DESCRIPTION "Build configuration:")
