=== debian/changelog ===
goldendict-webengine (24.05.05-1) unstable; urgency=medium

  * New upstream tag 24.05.05-LiXia.ecd1138c.

 -- Boyuan Yang <byang@debian.org>  Mon, 06 May 2024 23:43:43 -0400
