## goldendict-webengine 24.05.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 24.05.05
+        VERSION 24.05.13
         LANGUAGES CXX C)
 
 set(GOLDENDICT "goldendict") # binary/executable name
