=== debian/changelog ===
goldendict-webengine (24.05.13-1) unstable; urgency=medium

  * New upstream tag 24.05.13-alpha.2e88e3b2.
  * debian/patches/backport/e2e1ca...patch: Apply upstream patch to
    fix compilation against ffmpeg 7.0. (Closes: #1072416)

 -- Boyuan Yang <byang@debian.org>  Mon, 10 Jun 2024 14:41:57 -0400
