=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: goldendict-webengine
 Priority: optional
 Section: utils
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
+Maintainer: Boyuan Yang <byang@debian.org>
 Standards-Version: 4.6.2
 Build-Depends:
  debhelper-compat (= 13),
@@ -27,7 +26,7 @@
  libxtst-dev,
  libzim-dev,
  libzstd-dev,
- pkg-config,
+ pkgconf,
  qt5-qmake,
  qtbase5-dev,
  qtmultimedia5-dev,
