=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,9 @@
 
 %:
 	dh $@ --buildsystem=qmake
+
+execute_after_dh_clean:
+	rm -fv src/scripts/jquery-3.6.0.slim.min.js
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
